<?php

namespace OrganizationsManagement\Factory;

use Teknisa\Model\Teknisa\Entities\OmProdutoOrgVersao;
use Teknisa\Model\Util\NovoCodigo;

class ProdutoOrgVersao {
    
    public function save(OmProdutoOrgVersao $produtoOrgVersao = null, $nrProdutoOrgId, $productVersionId,
                         $currentUserId, $currentOrganizationId, $dateNow, $idAtivo = 'S', $parentId = null) {
        if(!$produtoOrgVersao) {
            $produtoOrgVersao = new OmProdutoOrgVersao();
            $novoCodigo = NovoCodigo::geraCodigo($currentOrganizationId, 'OM_PRODUTO_ORG_VERSAO', 1, 10, true);
            $produtoOrgVersao->setId($novoCodigo);
            $produtoOrgVersao->setDtinclusao($dateNow);
            $produtoOrgVersao->setNrorg($currentOrganizationId);
            $produtoOrgVersao->setCdoperinclusao($currentUserId);
            $produtoOrgVersao->setNrorginclusao($currentOrganizationId);
        }
        $produtoOrgVersao->setNrprodutoOrgId($nrProdutoOrgId);
        $produtoOrgVersao->setProductVersionId($productVersionId);
        $produtoOrgVersao->setIdativo($idAtivo);
        $produtoOrgVersao->setDtultatu($dateNow);
        $produtoOrgVersao->setCdoperultatu($currentUserId);
        $produtoOrgVersao->setNrorgultatu($currentOrganizationId);
        $produtoOrgVersao->setParentNrprodOrgId($parentId);

        return $produtoOrgVersao;
    }
}